function seqs = make_sequences(seg_array, max_duration)
% From an Nx3 segment array, this function produces
% a cell array of sequences
	seqs = {};
	current_seg = [];
	bouts = unique(seg_array(:,3));
	sample = 1;
	granularity = 5;
	max_duration = max_duration/granularity;
        max_length = 1000;
	for bout=1:length(bouts)
		in_bout = find(seg_array(:,3)==bouts(bout));
		dur = seg_array(in_bout,2) - seg_array(in_bout,1);
		dur = floor(dur/granularity);
		if max(dur) < max_duration
			seqs{sample} = [1 dur' 2];
			sample = sample + 1;
		end
	end
end
